<template>
  <div style="min-height: 90vh">
    <GToolbar
      :i18n="i18n"
      :available-elements="availableElements"
      @addDropDownMenuElement="addElement"
    />
    <div class="mb-4">
      <DccLocalizedTextBlock v-model="value.name" i18n="dcc.itemList.name" />
    </div>
    <EquipmentClass
      v-if="value.equipmentClass"
      ref="equipmentClass"
      v-model="value.equipmentClass"
      i18n="dcc.common.equipmentClassType.title"
      class="mb-4"
      optional
      level="second"
      wiki-entry="equipmentClass"
      @delete="deleteEquipmentClass"
    />
    <RichContent
      v-if="value.description"
      ref="description"
      v-model="value.description"
      i18n="dcc.itemList.description.title"
      class="mb-4"
      optional
      not-in-dialog
      @delete="deleteRichContent"
    />
    <Contact
      v-if="value.manufacturer"
      ref="manufacturer"
      v-model="value.manufacturer"
      not-strict
      i18n="dcc.itemList.manufacturer.title"
      level="third"
      class="mb-4"
      optional
      wiki-entry="manufacturer"
      @delete="deleteManufacturer"
    />
    <Contact
      v-if="value.owner"
      ref="owner"
      v-model="value.owner"
      level="third"
      optional
      i18n="dcc.itemList.owner.title"
      class="mb-4"
      wiki-entry="owner"
      @delete="deleteOwner"
    />
    <IdentificationList
      v-if="value.identifications"
      ref="identifications"
      v-model="value.identifications"
      optional
      level="second"
      class="mb-4"
      @delete="deleteIdentifications"
    />
    <div v-if="value.item.length > 0">
      <GCollapsibleCard
        v-for="(item, index) in value.item"
        :key="index"
        :title="getTitle(item)"
        class="mt-4"
        border
        wiki-entry="item"
        @move-up="moveUp(index)"
        @move-down="moveDown(index)"
        @remove="remove(index)"
      >
        <template #card-title-append>
          <GDropDownMenu
            i18n="form.addElement"
            :available-elements="availableElementsItem(item, index)"
            icon="add"
            :btn-class="level === 'third' ? 'theme--light' : 'theme--dark'"
            @addElement="addElementItem(item, index)"
          />
        </template>
        <Item ref="item" v-model="value.item[index]" :card="false" />
      </GCollapsibleCard>
    </div>
    <v-alert v-else color="warning" icon="warning" class="mt-4">
      {{ $t("dcc.itemList.empty") }}
    </v-alert>
  </div>
</template>

<script>
import {
  ContactType,
  ContactNotStrictType,
  IdentificationListType,
  ItemType,
  RichContentType,
  ItemQuantityListType,
  SoftwareListType,
} from "@d-ptb/dcc-js";
import { insertIf, removeFromArray, swap } from "assets/util/general";
import DccLocalizedTextBlock from "../../App/Form/XML/DccLocalizedTextBlock";
import GCollapsibleCard from "../../App/Common/GCollapsibleCard";
import { validatableMixin } from "../../Mixins/validatableMixin";
import Contact from "../Common/Contact";
import IdentificationList from "../Common/IdentificationList";
import Item from "./Item";
import RichContent from "~/components/DCC/Common/RichContent";
import GToolbar from "~/components/App/Common/GToolbar.vue";
import GDropDownMenu from "~/components/App/Common/GDropDownMenu.vue";
import EquipmentClass from "~/components/DCC/Common/EquipmentClass.vue";

export default {
  name: "ItemList",
  components: {
    EquipmentClass,
    GDropDownMenu,
    GToolbar,
    RichContent,
    IdentificationList,
    GCollapsibleCard,
    DccLocalizedTextBlock,
    Item,
    Contact,
  },
  mixins: [validatableMixin],
  props: {
    value: Object,
    i18n: {
      type: String,
      default: "dcc.itemList.title",
    },
    level: String,
  },
  data() {
    return {
      hasOwner: !!this.value.owner,
      lastOwner: null,
    };
  },
  computed: {
    customRules() {
      return [
        () => this.value.item.length > 0 || this.$t("dcc.itemList.empty"),
      ];
    },
    availableElements() {
      return [
        "equipmentClass",
        "description",
        "owner",
        "identifications",
        "manufacturer",
        "item",
      ]
        .filter((x) => !this.blacklist.includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.itemList.${x}.title`),
            value: x,
            addElement: () => this.addElement(x),
          };
        });
    },
    blacklist() {
      return [
        ...insertIf(this.value.equipmentClass, "equipmentClass"),
        ...insertIf(this.value.identifications, "identifications"),
        ...insertIf(this.value.owner, "owner"),
        ...insertIf(this.value.description, "description"),
        ...insertIf(this.value.manufacturer, "manufacturer"),
      ];
    },
  },
  watch: {
    "value.item"() {
      this.validate();
    },
  },
  methods: {
    getTitle(item) {
      const content = item.name
        ? item.name.getContent(this.$store.state.currentUsedLangISO639)
        : null;
      return `${this.$t("dcc.itemList.item.title")} ${
        content ? `- ${content._text}` : ""
      }`;
    },
    moveUp(index) {
      if (index > 0) {
        swap(this.value.item, index, index - 1);
      }
    },
    moveDown(index) {
      if (index < this.value.item.length - 1) {
        swap(this.value.item, index, index + 1);
      }
    },
    remove(index) {
      confirm(this.$t("dcc.itemList.confirmRemove")) &&
        removeFromArray(this.value.item, this.value.item[index]);
    },
    addElement(element) {
      switch (element) {
        case "equipmentClass":
          this.$set(this.value, "equipmentClass", []);
          break;
        case "identifications":
          this.$set(
            this.value,
            "identifications",
            new IdentificationListType()
          );
          break;
        case "owner":
          this.$set(this.value, "owner", new ContactType());
          break;
        case "manufacturer":
          this.$set(this.value, "manufacturer", new ContactNotStrictType());
          break;
        case "description":
          this.$set(this.value, "description", new RichContentType());
          break;
        case "item":
          this.value.item.push(new ItemType());
          this.$nextTick(() => {
            this.$vuetify.goTo(this.$refs.item[this.$refs.item.length - 1]);
          });
          return;
      }
      this.$nextTick(() => {
        this.$vuetify.goTo(this.$refs[element]);
      });
    },
    availableElementsItem(item, index) {
      return [
        "equipmentClass",
        "description",
        "installedSoftwares",
        "manufacturer",
        "itemQuantities",
      ]
        .filter((x) => !this.blacklistItem(item).includes(x))
        .map((x) => {
          return {
            text: this.$t(`dcc.itemList.item.${x}.title`),
            value: x,
            addElement: () => this.addElementItem(x, item, index),
          };
        });
    },
    blacklistItem(item) {
      return [
        ...insertIf(item.equipmentClass, "equipmentClass"),
        ...insertIf(item.description, "description"),
        ...insertIf(item.installedSoftwares, "installedSoftwares"),
        ...insertIf(item.manufacturer, "manufacturer"),
        ...insertIf(item.itemQuantities, "itemQuantities"),
      ];
    },
    addElementItem(element, item, index) {
      switch (element) {
        case "equipmentClass":
          this.$set(item, "equipmentClass", []);
          break;
        case "description":
          this.$set(item, "description", new RichContentType());
          break;
        case "installedSoftwares":
          this.$set(item, "installedSoftwares", new SoftwareListType());
          break;
        case "manufacturer":
          this.$set(item, "manufacturer", new ContactNotStrictType());
          break;
        case "itemQuantities":
          this.$set(item, "itemQuantities", new ItemQuantityListType());
          break;
      }
      this.$nextTick(() => {
        this.$vuetify.goTo(this.$refs.item[index].$refs[element]);
      });
    },
    deleteIdentifications() {
      confirm(this.$t("dcc.common.identificationListType.confirmRemove")) &&
        this.$delete(this.value, "identifications");
    },
    deleteRichContent() {
      confirm(this.$t("dcc.itemList.description.confirmRemove")) &&
        this.$delete(this.value, "description");
    },
    deleteEquipmentClass() {
      confirm(this.$t("dcc.common.equipmentClassType.confirmRemove")) &&
        this.$delete(this.value, "equipmentClass");
    },
    deleteOwner() {
      confirm(this.$t("dcc.itemList.owner.confirmRemove")) &&
        this.$delete(this.value, "owner");
    },
    deleteManufacturer() {
      confirm(this.$t("dcc.itemList.manufacturer.confirmRemove")) &&
        this.$delete(this.value, "manufacturer");
    },
  },
};
</script>
